#!/bin/bash
cd "${0%/*}"
cd ".."

PRODUCT="API AutoFlow"
PRODUCT_DATA_DIRECTORY="$(pwd)/data-autoflow"
CORE_APP="autoflow_core"

read -p "Clear mnesia (this will remove stored configuration) [y/N]? " -n 1 -r
echo    # (optional) move to a new line
if [[ $REPLY =~ ^[Yy]$ ]]
then
  rm -rf "${PRODUCT_DATA_DIRECTORY}/mnesia"
fi

read -p "Clean and rebuild [y/N]? " -n 1 -r
echo    # (optional) move to a new line
if [[ $REPLY =~ ^[Yy]$ ]]
then
  rm -rf _build
  npm --prefix ./ui install
  PRODUCT=$PRODUCT mix deps.get
fi

PRODUCT=$PRODUCT \
  MIX_ENV=dev \
  PRODUCT_DATA_DIRECTORY=${PRODUCT_DATA_DIRECTORY} \
  iex -S mix run --no-start \
  -e "Application.ensure_all_started(:store_mnesia); Application.ensure_all_started(:${CORE_APP}); Application.ensure_all_started(:web); Store.Mnesia.Application.cluster_connected(\"\")"
