#!/bin/bash
cd "${0%/*}"

VERSION=$(<../../../VERSION_API_AUTOFLOW.txt)

read -p "stage or production [stage]: " MODE
if [[ $MODE == "production" ]]; then
  AUTOFLOW_ENVIRONMENT=production
elif [[ $MODE == "stage" ]] || [[ $MODE == "" ]]; then
  AUTOFLOW_ENVIRONMENT=stage
else
  echo "Invalid mode"
  exit 1
fi

read -p "Push all builds [y/N]? " -n 1 -r
echo    # (optional) move to a new line
if [[ $REPLY =~ ^[Yy]$ ]]
then
  for ROLE in execution manager service store debugger
  do
    docker push "interactor/api-autoflow-saas:${AUTOFLOW_ENVIRONMENT}-${ROLE}-latest"
    docker push "interactor/api-autoflow-saas:${AUTOFLOW_ENVIRONMENT}-${ROLE}-${VERSION}"
  done
else
  read -p "Choose a role (execution manager service store debugger): " ROLE
  docker push "interactor/api-autoflow-saas:${AUTOFLOW_ENVIRONMENT}-${ROLE}-latest"
  docker push "interactor/api-autoflow-saas:${AUTOFLOW_ENVIRONMENT}-${ROLE}-${VERSION}"
fi
