#!/bin/bash
cd "${0%/*}"

VERSION=$(<../../../VERSION_API_AUTOFLOW.txt)

read -p "stage or production [stage]: " MODE
if [[ $MODE == "production" ]]; then
  ENVIRONMENT=production
elif [[ $MODE == "stage" ]] || [[ $MODE == "" ]]; then
  ENVIRONMENT=stage
else
  echo "Invalid mode"
  exit 1
fi

read -p "Update all builds (${VERSION}) [y/N]? " -n 1 -r
echo    # (optional) move to a new line
if [[ $REPLY =~ ^[Yy]$ ]]
then
  for ROLE in execution manager service store
  do
    docker build \
      --build-arg ENVIRONMENT=${ENVIRONMENT} \
      --build-arg ROLE=${ROLE} \
      --tag "interactor/api-autoflow-saas:${ENVIRONMENT}-${ROLE}-latest" \
      --tag "interactor/api-autoflow-saas:${ENVIRONMENT}-${ROLE}-${VERSION}" \
      -f Dockerfile ../../..
  done
  for ROLE in execution manager service store
  do
    docker push "interactor/api-autoflow-saas:${ENVIRONMENT}-${ROLE}-latest"
    docker push "interactor/api-autoflow-saas:${ENVIRONMENT}-${ROLE}-${VERSION}"
  done
else
  read -p "Choose a role (execution manager service store debugger): " ROLE
  docker build \
    --build-arg ENVIRONMENT=${ENVIRONMENT} \
    --build-arg ROLE=${ROLE} \
    --tag "interactor/api-autoflow-saas:${ENVIRONMENT}-${ROLE}-latest" \
    --tag "interactor/api-autoflow-saas:${ENVIRONMENT}-${ROLE}-${VERSION}" \
    -f Dockerfile ../../..
  docker push "interactor/api-autoflow-saas:${ENVIRONMENT}-${ROLE}-latest"
  docker push "interactor/api-autoflow-saas:${ENVIRONMENT}-${ROLE}-${VERSION}"
fi
